
Teff=zeros(1,NE);

for k=1:NE
    
	sig1=zeros(Np); sig2=zeros(Np);
    
	ck=-1*((E(k)+zplus-U1(1)-UB(1))/(2*t0)); ka=acos(ck);
	sig1(1,1)=-t0*exp(1i*ka); gam1=1i*(sig1-sig1');
    
	ck=-1*((E(k)+zplus-U1(Np)-UB(Np))/(2*t0)); ka=acos(ck);
    sig2(Np,Np)=-t0*exp(1i*ka); gam2=1i*(sig2-sig2');
    
	sigin1=f1*gam1; sigin2=f2*gam2;
    
	G=inv(((E(k)+zplus)*eye(Np))-T-diag(U1+UB)-sig1-sig2);
   	Gn=G*(sigin1+sigin2)*G';
    
    error=1;
    while(error>1e-4)
        
        sigS=diag(D*diag(G)); % dijagonalna matrica
        Gnova=inv(((E(k)+zplus)*eye(Np))-T-diag(U1+UB)-sig1-sig2-sigS);
        err1=sum(sum(abs(G-Gnova)))/(sum(sum(abs(G)+abs(Gnova))));
        G=(0.5*G)+(0.5*Gnova); % mijesanje stare i nove matrice po 50%
        
        siginS=diag(D*diag(Gn)); % dijagonalna matrica
        Gnnova=G*(sigin1+sigin2+siginS)*G';
        err2=sum(sum(abs(Gn-Gnnova)))/(sum(sum(abs(Gn)+abs(Gnnova))));
        Gn=(0.5*Gn)+(0.5*Gnnova); % mijesanje stare i nove matrice po 50%
        
        error=max([err1,err2]); % konvergencija po G i Gn
        
    end
    G=Gnova; Gn=Gnnova; A=1i*(G-G');
    
    % efektivna transmisija
	Teff(k)=(1/(f1-f2))*real(trace(sigin1*A)-trace(gam1*Gn));
    
end

